﻿Imports Syncfusion.JavaScript.Web
Imports System.Web.Services
Imports System.Web.Script.Services

Public Class Sample
    Inherits System.Web.UI.Page
    Private order As New List(Of Orders)()
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'BindDataSource()
        'ViewState("DataSource") = order
    End Sub
    <WebMethod> _
<ScriptMethod(ResponseFormat:=ResponseFormat.Json)> _
    Public Shared Function Data(skip As Integer, take As Integer) As Object

        Dim DataSource = New NorthWndDataContext().Orders.ToList()
        Dim ds As New DataResult()
        ds.result = DataSource.Skip(skip).Take(take)
        ds.count = DataSource.Count()
        Return ds

    End Function
    Public Class DataResult
        Public Property result() As IEnumerable(Of Order)
            Get
                Return m_result
            End Get
            Set(value As IEnumerable(Of Order))
                m_result = value
            End Set
        End Property
        Private m_result As IEnumerable(Of Order)
        Public Property count() As Integer
            Get
                Return m_count
            End Get
            Set(value As Integer)
                m_count = Value
            End Set
        End Property
        Private m_count As Integer
    End Class
    Private Sub BindDataSource()

        Dim orderId As Integer = 10000
        Dim empId As Integer = 0
        For i As Integer = 1 To 8
            order.Add(New Orders(orderId + 1, "VINET", empId + 1, 32.38, New DateTime(2014, 12, 25), "Reims"))
            order.Add(New Orders(orderId + 2, "TOMSP", empId + 2, 11.61, New DateTime(2014, 12, 21), "Munster"))
            order.Add(New Orders(orderId + 3, "ANATER", empId + 3, 45.34, New DateTime(2014, 10, 18), "Berlin"))
            order.Add(New Orders(orderId + 4, "ALFKI", empId + 4, 37.28, New DateTime(2014, 11, 23), "Mexico"))
            order.Add(New Orders(orderId + 5, "FRGYE", empId + 5, 67.0, New DateTime(2014, 5, 5), "Colchester"))
            order.Add(New Orders(orderId + 6, "JGERT", empId + 6, 23.32, New DateTime(2014, 10, 18), "Newyork"))
            orderId += 6
            empId += 6
        Next
        Me.Grid.DataSource = order
        Me.Grid.DataBind()

    End Sub

    <Serializable> _
    Public Class Orders

        Public Sub New()
        End Sub

        Public Sub New(orderId As Integer, customerId As String, empId As Integer, freight As Double, orderDate As DateTime, shipCity As String)
            Me.OrderID = orderId
            Me.CustomerID = customerId
            Me.EmployeeID = empId
            Me.Freight = freight
            Me.OrderDate = orderDate
            Me.ShipCity = shipCity
        End Sub

        Public Property OrderID() As Integer
            Get
                Return m_OrderID
            End Get
            Set(value As Integer)
                m_OrderID = value
            End Set
        End Property
        Private m_OrderID As Integer
        Public Property CustomerID() As String
            Get
                Return m_CustomerID
            End Get
            Set(value As String)
                m_CustomerID = value
            End Set
        End Property
        Private m_CustomerID As String
        Public Property EmployeeID() As Integer
            Get
                Return m_EmployeeID
            End Get
            Set(value As Integer)
                m_EmployeeID = value
            End Set
        End Property
        Private m_EmployeeID As Integer
        Public Property Freight() As Double
            Get
                Return m_Freight
            End Get
            Set(value As Double)
                m_Freight = value
            End Set
        End Property
        Private m_Freight As Double
        Public Property OrderDate() As DateTime
            Get
                Return m_OrderDate
            End Get
            Set(value As DateTime)
                m_OrderDate = value
            End Set
        End Property
        Private m_OrderDate As DateTime
        Public Property ShipCity() As String
            Get
                Return m_ShipCity
            End Get
            Set(value As String)
                m_ShipCity = value
            End Set
        End Property
        Private m_ShipCity As String
    End Class
    Protected Sub EditEvents_ServerEditRow(sender As Object, e As GridEventArgs)
        EditAction(e.EventType, e.Arguments("data"))
    End Sub

    Protected Sub EditEvents_ServerAddRow(sender As Object, e As GridEventArgs)
        EditAction(e.EventType, e.Arguments("data"))
    End Sub

    Protected Sub EditEvents_ServerDeleteRow(sender As Object, e As GridEventArgs)
        EditAction(e.EventType, e.Arguments("data"))
    End Sub
    Protected Sub EditAction(eventType As String, record As Object)
        Dim data As List(Of Orders) = TryCast(ViewState("DataSource"), List(Of Orders))
        Dim KeyVal__1 As Dictionary(Of String, Object) = TryCast(record, Dictionary(Of String, Object))
        If eventType = "endEdit" Then
            Dim value As New Orders()
            For Each keyval__2 As KeyValuePair(Of String, Object) In KeyVal__1
                If keyval__2.Key = "OrderID" Then
                    value = data.Where(Function(d) d.OrderID = Convert.ToInt32(keyval__2.Value)).FirstOrDefault()
                    value.OrderID = Convert.ToInt32(keyval__2.Value)
                ElseIf keyval__2.Key = "CustomerID" Then
                    value.CustomerID = Convert.ToString(keyval__2.Value)
                ElseIf keyval__2.Key = "EmployeeID" Then
                    value.EmployeeID = Convert.ToInt32(keyval__2.Value)
                ElseIf keyval__2.Key = "Freight" Then
                    value.Freight = Convert.ToDouble(keyval__2.Value)
                ElseIf keyval__2.Key = "ShipCity" Then
                    value.ShipCity = Convert.ToString(keyval__2.Value)
                End If
            Next

        ElseIf eventType = "endAdd" Then
            Dim newRecord As New Orders()
            For Each keyval__2 As KeyValuePair(Of String, Object) In KeyVal__1
                If keyval__2.Key = "OrderID" Then
                    newRecord.OrderID = Convert.ToInt32(keyval__2.Value)
                ElseIf keyval__2.Key = "CustomerID" Then
                    newRecord.CustomerID = Convert.ToString(keyval__2.Value)
                ElseIf keyval__2.Key = "EmployeeID" Then
                    newRecord.EmployeeID = Convert.ToInt32(keyval__2.Value)
                ElseIf keyval__2.Key = "Freight" Then
                    newRecord.Freight = Convert.ToDouble(keyval__2.Value)
                ElseIf keyval__2.Key = "ShipCity" Then
                    newRecord.ShipCity = Convert.ToString(keyval__2.Value)
                End If
            Next
            data.Insert(0, newRecord)

        ElseIf eventType = "endDelete" Then
            For Each keyval__2 As KeyValuePair(Of String, Object) In KeyVal__1
                If keyval__2.Key = "OrderID" Then
                    Dim value As Orders = data.Where(Function(d) d.OrderID = CInt(keyval__2.Value)).FirstOrDefault()
                    data.Remove(value)
                End If
            Next
        End If
        ViewState("DataSource") = data
        Me.Grid.DataSource = data
        Me.Grid.DataBind()
    End Sub
End Class